#! /usr/local/bin/python
#-*- coding: utf-8 -*-

#
# This script generates the base of hash values.
#

from __future__ import with_statement

import hashlib
import pickle
import rsa


# Files to scan
number_of_files_to_scan = 5
file0 = "/etc/ssh/ssh_config"
file1 = "/etc/security/limits.conf"
file2 = "/boot/grub/menu.lst"
file3 = "/etc/passwd"
file4 = "/etc/shadow"




def hash_file(target_file):
    """Hash the file given in parameter.
    """
    sha1_hash = hashlib.sha1()
    opened_file = None
    hashed_data = None

    # Handle the errors that may happen
    try:
        opened_file = open(target_file, "r")
        data = opened_file.read()
    except:
        # The specified file does not exist,
        # remove from the list.
        print "File", target_file, "does not exist."
        globals()['number_of_files_to_scan'] = \
            globals()['number_of_files_to_scan'] - 1
        del list_of_files[list_of_files.index(target_file)]
    finally:
        if opened_file is not None:
            opened_file.close()

    if opened_file is not None:
        sha1_hash.update(data)
        hashed_data = sha1_hash.hexdigest()

    return hashed_data



if __name__ == '__main__':
    # Point of entry in execution mode.
    print "Loading public key"

    # address of the saved base of hash values :
    base_location = "/home/cedric/documents/cours/M2/projet_transversal/pyHIDS/base"
    # address of the public key
    pub_key_location = "/home/cedric/documents/cours/M2/projet_transversal/pyHIDS/cle_pub"

    # Load the public key to crypt the result.
    with open(pub_key_location, "r") as key:
        pub_key = pickle.load(key)

    # Open the base of hash values
    try:
        base = open(base_location, "w")
    except Exception , e:
        print "Error :", e
        exit(0)

    # Parse the files to scan in a list
    list_of_files = []
    for i in range(number_of_files_to_scan):
        list_of_files.append(globals()["file"+str(i)])

    print "Generating data base..."
    # Hash and write each files
    for file in list_of_files:
        hash_value = hash_file(file)
        if hash_value is not None:
            line = file + ":" + hash_value + ":"
            encrypted_line = rsa.encrypt(line, pub_key)
            encrypted_line = encrypted_line.replace('\n', '')
            base.write(encrypted_line+"\n")
    print number_of_files_to_scan, "files in the base."
    base.close()
